Index: trunk/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 588)
+++ trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -129,5 +129,4 @@
   if (m_bUseSAO)
   {
-#if HM_CLEANUP_SAO
 #if AUXILIARY_PICTURES
     m_cEncSAO.create( getSourceWidth(), getSourceHeight(), m_chromaFormatIDC, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
@@ -140,11 +139,4 @@
     m_cEncSAO.createEncData();
 #endif
-#else
-    m_cEncSAO.setSaoLcuBoundary(getSaoLcuBoundary());
-    m_cEncSAO.setSaoLcuBasedOptimization(getSaoLcuBasedOptimization());
-    m_cEncSAO.setMaxNumOffsetsPerPic(getMaxNumOffsetsPerPic());
-    m_cEncSAO.create( getSourceWidth(), getSourceHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight );
-    m_cEncSAO.createEncBuffer();
-#endif
   }
 #if ADAPTIVE_QP_SELECTION
@@ -161,33 +153,30 @@
                       g_uiMaxCUWidth, g_uiMaxCUHeight, m_RCKeepHierarchicalBit, m_RCUseLCUSeparateModel, m_GOPList );
   }
-  // if SBAC-based RD optimization is used
-  if( m_bUseSBACRD )
-  {
-    m_pppcRDSbacCoder = new TEncSbac** [g_uiMaxCUDepth+1];
+
+  m_pppcRDSbacCoder = new TEncSbac** [g_uiMaxCUDepth+1];
 #if FAST_BIT_EST
-    m_pppcBinCoderCABAC = new TEncBinCABACCounter** [g_uiMaxCUDepth+1];
-#else
-    m_pppcBinCoderCABAC = new TEncBinCABAC** [g_uiMaxCUDepth+1];
-#endif
-    
-    for ( Int iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
-    {
-      m_pppcRDSbacCoder[iDepth] = new TEncSbac* [CI_NUM];
+  m_pppcBinCoderCABAC = new TEncBinCABACCounter** [g_uiMaxCUDepth+1];
+#else
+  m_pppcBinCoderCABAC = new TEncBinCABAC** [g_uiMaxCUDepth+1];
+#endif
+
+  for ( Int iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
+  {
+    m_pppcRDSbacCoder[iDepth] = new TEncSbac* [CI_NUM];
 #if FAST_BIT_EST
-      m_pppcBinCoderCABAC[iDepth] = new TEncBinCABACCounter* [CI_NUM];
-#else
-      m_pppcBinCoderCABAC[iDepth] = new TEncBinCABAC* [CI_NUM];
-#endif
-      
-      for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
-      {
-        m_pppcRDSbacCoder[iDepth][iCIIdx] = new TEncSbac;
+    m_pppcBinCoderCABAC[iDepth] = new TEncBinCABACCounter* [CI_NUM];
+#else
+    m_pppcBinCoderCABAC[iDepth] = new TEncBinCABAC* [CI_NUM];
+#endif
+
+    for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
+    {
+      m_pppcRDSbacCoder[iDepth][iCIIdx] = new TEncSbac;
 #if FAST_BIT_EST
-        m_pppcBinCoderCABAC [iDepth][iCIIdx] = new TEncBinCABACCounter;
-#else
-        m_pppcBinCoderCABAC [iDepth][iCIIdx] = new TEncBinCABAC;
-#endif
-        m_pppcRDSbacCoder   [iDepth][iCIIdx]->init( m_pppcBinCoderCABAC [iDepth][iCIIdx] );
-      }
+      m_pppcBinCoderCABAC [iDepth][iCIIdx] = new TEncBinCABACCounter;
+#else
+      m_pppcBinCoderCABAC [iDepth][iCIIdx] = new TEncBinCABAC;
+#endif
+      m_pppcRDSbacCoder   [iDepth][iCIIdx]->init( m_pppcBinCoderCABAC [iDepth][iCIIdx] );
     }
   }
@@ -226,24 +215,22 @@
     m_pcSbacCoders[ui].init( &m_pcBinCoderCABACs[ui] );
   }
-  if( m_bUseSBACRD )
-  {
-    m_ppppcRDSbacCoders      = new TEncSbac***    [iNumSubstreams];
-    m_ppppcBinCodersCABAC    = new TEncBinCABAC***[iNumSubstreams];
-    for ( UInt ui = 0 ; ui < iNumSubstreams ; ui++ )
-    {
-      m_ppppcRDSbacCoders[ui]  = new TEncSbac** [g_uiMaxCUDepth+1];
-      m_ppppcBinCodersCABAC[ui]= new TEncBinCABAC** [g_uiMaxCUDepth+1];
-      
-      for ( Int iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
-      {
-        m_ppppcRDSbacCoders[ui][iDepth]  = new TEncSbac*     [CI_NUM];
-        m_ppppcBinCodersCABAC[ui][iDepth]= new TEncBinCABAC* [CI_NUM];
-
-        for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
-        {
-          m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx] = new TEncSbac;
-          m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx] = new TEncBinCABAC;
-          m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx]->init( m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx] );
-        }
+
+  m_ppppcRDSbacCoders      = new TEncSbac***    [iNumSubstreams];
+  m_ppppcBinCodersCABAC    = new TEncBinCABAC***[iNumSubstreams];
+  for ( UInt ui = 0 ; ui < iNumSubstreams ; ui++ )
+  {
+    m_ppppcRDSbacCoders[ui]  = new TEncSbac** [g_uiMaxCUDepth+1];
+    m_ppppcBinCodersCABAC[ui]= new TEncBinCABAC** [g_uiMaxCUDepth+1];
+
+    for ( Int iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
+    {
+      m_ppppcRDSbacCoders[ui][iDepth]  = new TEncSbac*     [CI_NUM];
+      m_ppppcBinCodersCABAC[ui][iDepth]= new TEncBinCABAC* [CI_NUM];
+
+      for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
+      {
+        m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx] = new TEncSbac;
+        m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx] = new TEncBinCABAC;
+        m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx]->init( m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx] );
       }
     }
@@ -259,58 +246,50 @@
   if (m_cSPS.getUseSAO())
   {
-#if HM_CLEANUP_SAO
     m_cEncSAO.destroyEncData();
     m_cEncSAO.destroy();
-#else
-    m_cEncSAO.destroy();
-    m_cEncSAO.destroyEncBuffer();
-#endif
   }
   m_cLoopFilter.        destroy();
   m_cRateCtrl.          destroy();
-  // SBAC RD
-  if( m_bUseSBACRD )
-  {
-    Int iDepth;
+
+  Int iDepth;
+  for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
+  {
+    for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
+    {
+      delete m_pppcRDSbacCoder[iDepth][iCIIdx];
+      delete m_pppcBinCoderCABAC[iDepth][iCIIdx];
+    }
+  }
+
+  for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
+  {
+    delete [] m_pppcRDSbacCoder[iDepth];
+    delete [] m_pppcBinCoderCABAC[iDepth];
+  }
+
+  delete [] m_pppcRDSbacCoder;
+  delete [] m_pppcBinCoderCABAC;
+
+  for ( UInt ui = 0; ui < m_iNumSubstreams; ui++ )
+  {
     for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
     {
       for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
       {
-        delete m_pppcRDSbacCoder[iDepth][iCIIdx];
-        delete m_pppcBinCoderCABAC[iDepth][iCIIdx];
-      }
-    }
-    
+        delete m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx];
+        delete m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx];
+      }
+    }
+
     for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
     {
-      delete [] m_pppcRDSbacCoder[iDepth];
-      delete [] m_pppcBinCoderCABAC[iDepth];
-    }
-    
-    delete [] m_pppcRDSbacCoder;
-    delete [] m_pppcBinCoderCABAC;
-
-    for ( UInt ui = 0; ui < m_iNumSubstreams; ui++ )
-    {
-      for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
-      {
-        for (Int iCIIdx = 0; iCIIdx < CI_NUM; iCIIdx ++ )
-        {
-          delete m_ppppcRDSbacCoders  [ui][iDepth][iCIIdx];
-          delete m_ppppcBinCodersCABAC[ui][iDepth][iCIIdx];
-        }
-      }
-
-      for ( iDepth = 0; iDepth < g_uiMaxCUDepth+1; iDepth++ )
-      {
-        delete [] m_ppppcRDSbacCoders  [ui][iDepth];
-        delete [] m_ppppcBinCodersCABAC[ui][iDepth];
-      }
-      delete[] m_ppppcRDSbacCoders  [ui];
-      delete[] m_ppppcBinCodersCABAC[ui];
-    }
-    delete[] m_ppppcRDSbacCoders;
-    delete[] m_ppppcBinCodersCABAC;
-  }
+      delete [] m_ppppcRDSbacCoders  [ui][iDepth];
+      delete [] m_ppppcBinCodersCABAC[ui][iDepth];
+    }
+    delete[] m_ppppcRDSbacCoders  [ui];
+    delete[] m_ppppcBinCodersCABAC[ui];
+  }
+  delete[] m_ppppcRDSbacCoders;
+  delete[] m_ppppcBinCodersCABAC;
   delete[] m_pcSbacCoders;
   delete[] m_pcBinCoderCABACs;
@@ -525,7 +504,4 @@
     TComPic *pcTopField;
     xGetNewPicBuffer( pcTopField );
-#if !HM_CLEANUP_SAO
-    pcTopField->getPicSym()->allocSaoParam(&m_cEncSAO);
-#endif
     pcTopField->setReconMark (false);
     
@@ -568,7 +544,4 @@
     TComPic* pcBottomField;
     xGetNewPicBuffer( pcBottomField );
-#if !HM_CLEANUP_SAO
-    pcBottomField->getPicSym()->allocSaoParam(&m_cEncSAO);
-#endif
     pcBottomField->setReconMark (false);
    
@@ -652,7 +625,4 @@
     TComPic *pcTopField;
     xGetNewPicBuffer( pcTopField );
-#if !HM_CLEANUP_SAO
-    pcTopField->getPicSym()->allocSaoParam(&m_cEncSAO);
-#endif
     pcTopField->setReconMark (false);
     
@@ -706,7 +676,4 @@
     TComPic* pcBottomField;
     xGetNewPicBuffer( pcBottomField );
-#if !HM_CLEANUP_SAO
-    pcBottomField->getPicSym()->allocSaoParam(&m_cEncSAO);
-#endif
     pcBottomField->setReconMark (false);
     
@@ -912,10 +879,4 @@
 #endif
     }
-#if !HM_CLEANUP_SAO
-    if (getUseSAO())
-    {
-      rpcPic->getPicSym()->allocSaoParam(&m_cEncSAO);
-    }
-#endif
     m_cListPic.pushBack( rpcPic );
   }
@@ -1001,5 +962,4 @@
   
   m_cSPS.setTMVPFlagsPresent(false);
-  m_cSPS.setUseLossless   ( m_useLossless  );
 
   m_cSPS.setMaxTrSize   ( 1 << m_uiQuadtreeTULog2MaxSize );
@@ -1038,5 +998,5 @@
   m_cSPS.setMaxTLayers( m_maxTempLayer );
   m_cSPS.setTemporalIdNestingFlag( ( m_maxTempLayer == 1 ) ? true : false );
-  for ( i = 0; i < m_cSPS.getMaxTLayers(); i++ )
+  for ( i = 0; i < min(m_cSPS.getMaxTLayers(),(UInt) MAX_TLAYER); i++ )
   {
     m_cSPS.setMaxDecPicBuffering(m_maxDecPicBuffering[i], i);
@@ -1098,49 +1058,7 @@
   Bool bUseDQP = (getMaxCuDQPDepth() > 0)? true : false;
 
-#if REPN_FORMAT_IN_VPS
-  Int lowestQP;
-#if O0096_REP_FORMAT_INDEX
-  if( m_layerId == 0 )
-  {
-    lowestQP = - m_cSPS.getQpBDOffsetY();
-  }
-  else
-  {
-    lowestQP = - (m_cVPS.getVpsRepFormat( m_cVPS.getVpsRepFormatIdx( m_cSPS.getUpdateRepFormatFlag() ? m_cSPS.getUpdateRepFormatIndex() : m_layerId ) )->getBitDepthVpsLuma() - 8) * 6;
-  }
-#else
-  if( m_layerId == 0 || m_cSPS.getUpdateRepFormatFlag() )
-  {
-    lowestQP = - m_cSPS.getQpBDOffsetY();
-  }
-  else
-  {
-    lowestQP = - (m_cVPS.getVpsRepFormat( m_cVPS.getVpsRepFormatIdx( m_layerId ) )->getBitDepthVpsLuma() - 8) * 6;
-  }
-#endif
-#else
-  Int lowestQP = - m_cSPS.getQpBDOffsetY();
-#endif
-
-  if(getUseLossless())
-  {
-    if ((getMaxCuDQPDepth() == 0) && (getMaxDeltaQP() == 0 ) && (getQP() == lowestQP) )
-    {
-      bUseDQP = false;
-    }
-    else
-    {
-      bUseDQP = true;
-    }
-  }
-  else
-  {
-    if(bUseDQP == false)
-    {
-      if((getMaxDeltaQP() != 0 )|| getUseAdaptiveQP())
-      {
-        bUseDQP = true;
-      }
-    }
+  if((getMaxDeltaQP() != 0 )|| getUseAdaptiveQP())
+  {
+    bUseDQP = true;
   }
 
Index: trunk/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 588)
+++ trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -73,12 +73,5 @@
   UInt                    m_uiNumAllPicCoded;             ///< number of coded pictures
   TComList<TComPic*>      m_cListPic;                     ///< dynamic list of pictures
-#if SVC_EXTENSION 
-  static Int              m_iSPSIdCnt;                    ///< next Id number for SPS    
-  static Int              m_iPPSIdCnt;                    ///< next Id number for PPS    
-#if AVC_SYNTAX
-  fstream*                m_pBLSyntaxFile;
-#endif
-#endif
-  
+ 
   // encoder search
   TEncSearch              m_cSearch;                      ///< encoder search class
@@ -130,5 +123,9 @@
   
 #if SVC_EXTENSION
-
+  static Int              m_iSPSIdCnt;                    ///< next Id number for SPS    
+  static Int              m_iPPSIdCnt;                    ///< next Id number for PPS    
+#if AVC_SYNTAX
+  fstream*                m_pBLSyntaxFile;
+#endif
   TEncTop**               m_ppcTEncTop;
   TEncTop*                getLayerEnc(UInt layer)   { return m_ppcTEncTop[layer]; }
@@ -163,5 +160,5 @@
   Void  xInitRPS          (Bool isFieldCoding);           ///< initialize PPS from encoder options
 #if SVC_EXTENSION
-  Void xInitILRP();
+  Void  xInitILRP();
 #endif
 public:
@@ -210,4 +207,9 @@
   Int getReferencePictureSetIdxForSOP(TComSlice* slice, Int POCCurr, Int GOPid );
   TComScalingList*        getScalingList        () { return  &m_scalingList;         }
+  // -------------------------------------------------------------------------------------------------------------------
+  // encoder function
+  // -------------------------------------------------------------------------------------------------------------------
+
+  /// encode several number of pictures until end-of-sequence
 #if SVC_EXTENSION
   Void                    setLayerEnc(TEncTop** p) {m_ppcTEncTop = p;}
@@ -224,12 +226,4 @@
 #endif
   Window&  getScaledRefLayerWindow(Int x)            { return m_scaledRefLayerWindow[x]; }
-#endif //SVC_EXTENSION
-
-  // -------------------------------------------------------------------------------------------------------------------
-  // encoder function
-  // -------------------------------------------------------------------------------------------------------------------
-
-  /// encode several number of pictures until end-of-sequence
-#if SVC_EXTENSION
   TComPic** getIlpList() { return m_cIlpPic; }
 #if REF_IDX_MFM
@@ -281,2 +275,3 @@
 
 #endif // __TENCTOP__
+
Index: trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 588)
+++ trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h
===================================================================
--- trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h	(revision 588)
+++ trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp
===================================================================
--- trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 588)
+++ trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h
===================================================================
--- trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h	(revision 588)
+++ trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/libmd5/MD5.h
===================================================================
--- trunk/source/Lib/libmd5/MD5.h	(revision 588)
+++ trunk/source/Lib/libmd5/MD5.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: trunk/source/Lib/libmd5/libmd5.h
===================================================================
--- trunk/source/Lib/libmd5/libmd5.h	(revision 588)
+++ trunk/source/Lib/libmd5/libmd5.h	(revision 595)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
